export type Point = {
  lon: number;
  lat: number;
};

export type Step = Point & {
  duration: number;
  distance?: number;
};

export type RouteRequest = {
  waypoints: Point[];
  detailsSettings?: { points: boolean; steps: boolean };
};

export type RouteResponse = {
  distance: number;
  duration: number;
  fwdAzimuth: number;
  backAzimuth: number;
  distanceAzimuth: number;
  points: Point[];
  steps?: Step[];
};

export interface GeorouterService {
  getRoute(request: RouteRequest): Promise<RouteResponse>;
}
