import { AdDeletedMessageHandler } from '@modules/ad/interface/message-handlers/ad-deleted.message-handler';
import { CommandBus } from '@nestjs/cqrs';
import { Test, TestingModule } from '@nestjs/testing';

const adDeletedMessage =
  '{"aggregateId":"4eb6a6af-ecfd-41c3-9118-473a507014d4"}';

const mockCommandBus = {
  execute: jest.fn(),
};

describe('Ad Deleted Message Handler', () => {
  let adDeletedMessageHandler: AdDeletedMessageHandler;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        {
          provide: CommandBus,
          useValue: mockCommandBus,
        },
        AdDeletedMessageHandler,
      ],
    }).compile();

    adDeletedMessageHandler = module.get<AdDeletedMessageHandler>(
      AdDeletedMessageHandler,
    );
  });

  afterEach(async () => {
    jest.clearAllMocks();
  });

  it('should be defined', () => {
    expect(adDeletedMessageHandler).toBeDefined();
  });

  it('should call the delete command', async () => {
    jest.spyOn(mockCommandBus, 'execute');
    await adDeletedMessageHandler.adDeleted(adDeletedMessage);
    expect(mockCommandBus.execute).toHaveBeenCalledTimes(1);
  });
});
